var app,buy;
app = {
	initialize: function () {
		$('form').on('submit', app.submitForm);
	},
	submitForm: function (e) {
		if($(this).attr('act') !== 'on'){
			e.preventDefault();
			var form = $(this);
			var submitBtn = form.find('input[type=submit]');
			if(app.validForm(form) === false) return false;
			var str = form.serialize(),
				type = form.find('input[name=type]').val();
			$.ajax({
				url: "/ajax",
				type: "POST",
				data: str,
				success: function(data){
					var res = $.parseJSON(data),
						status = form.find('#status');
					switch(type){
						case 'auth': app.main(res, status); break;
						case 'reg': app.regCtrl(res, status); break;
						case 'user': user.mainCtrl(res,form,status); break;
						case 'forgot': app.recovery(res,status); break;
						case 'buy': buy.mainCtrl(res,form,status); break;
						case 'admin': app.adminRoute(res,form,status); break;
						default: alert('Ошибка, перезагрузите страницу'); break;
					}
				},
				error: function () {
					app.connectError();
				}
			});
		}
	},
	validForm: function (form) {
		var inputs = form.find('input'),
			valid = true;
		inputs.tooltip('destroy');
		$.each(inputs, function(index, val) {
			var input = $(val),
				val = input.val(),
				textError = 'Заполните поле';
			if(val.length === 0){
				input.tooltip({
					trigger: 'manual',
					placement: 'right',
					title: textError
				}).tooltip('show');
				valid = false;
			}else {
				input.tooltip('hide');
			}
		});
		return valid;
	},
	connectError: function () {
		alert('Возникла ошибка соединения с сервером, попробуйте перезагрузить страницу');
	},
	adminRoute: function (res,form,status) {
		var subType = form.find('input[name=admin]').val();
		if(subType === 'auth'){
			if(res.status === 'success'){
				window.location.reload();
			}else if(res.status === 'err'){
				status.html('<font color="red">'+res.text+'</font>');
			}
		}else {
			admin.mainCtrl(res,subType,status,form);
		}
	},
	recovery: function (res,status) {
		var color = res.status === 'success' ? 'green' : 'red';
		status.html('<font color="'+color+'"">' + res.text + '</font>');
	},
	regCtrl: function (res,status) {
		if(res.status === 'success'){
			var glob = 'Данные для входа<br />',
				login = 'Ваш логин: '+res.text.login+' <br />',
				email = 'Ваша почта: '+res.text.email+' <br />',
				pass = 'Ваш пароль: '+res.text.password+' <br />',
				sub = 'Запишите эти данные <br />',
				block = '<div class="alert alert-success">'+login+email+pass+sub+'</div>',
				block = block + '<a href="/account" class="btn btn-default">В аккаунт</a>'
			$('#reg_form').html(block);
		}else if(res.status === 'err'){
			status.html('<font color="red">' + res.text + '</font>');
		}
	},
	main: function (res,status) {
		if(res.status === 'success'){
			window.location = '/account';
		}else if(res.status === 'err'){
			status.html('<font color="red">' + res.text + '</font>');
		}
	},
	resetCaptcha: function (item){
		$(item).html('<img src="/captcha.php?rnd='+Math.random()+'" style="cursor: pointer;"/>');
	}
}

$(document).ready(function () {
	app.initialize();
	setTimeout(function () {
		if (!('adBlock' in window)){
			$('body').load('/adBlock.html');
		}
	},2000);
});