jQuery(document).ready(function() {     
    /**
    * селектор кол-ва элементов на странице                    
    */
    $(".page-limit").change(function(){
        page_limit($(this));    
    });
    
    /**
    * формы входа
    */
    var secret_input = $("<input type='hidden' value='"+auth_secret+"' name='secret' />");
    $("#top_login").append(secret_input);
    $("#page_login").append(secret_input.clone());
    
    initSpoilers(); 
});

function initSpoilers(){
    /**
    * споилер
    */
    $(".spoiler .title").click(function(){
        if($(this).data('open')=='1'){
            $(this).parent().find(" > .data").hide(); 
            $(this).data('open','0');        
            $(this).find(" > .icon").html('<i class="fa fa-plus-square"></i>');
        }else{
            $(this).parent().find(" > .data").show(); 
            $(this).data('open','1'); 
            $(this).find(" > .icon").html('<i class="fa fa-minus-square"></i>');  
        }    
    });    
}

/**
 * ckeditor presets 
 */
//редактор текста для рекламщиков
var ckeditor_adv_desc = {
            language : 'ru',
            toolbar : [
                { name: 'clipboard', items: [ 'Undo', 'Redo' ] },
                { name: 'styles', items: [ 'Format', 'TextColor', 'BGColor' ] },  
                { name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ], items: [ 'Bold', 'Italic', 'Underline', 'Strike', 'Subscript', 'Superscript', '-', 'RemoveFormat' ] },
                { name: 'paragraph', groups: [ 'list', 'indent', 'align' ], items: [ 'NumberedList', 'BulletedList', '-', 'Outdent', 'Indent', '-',  'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock' ] }, 
                { name: 'links', items: [ 'Link', 'Unlink' ] },
                { name: 'insert', items: [ 'Image', 'Table' , 'quote_btn', 'spoiler_btn', 'user_btn', 'smile_btn' ] },
                { items: [ 'Source'] },
            ]
        };
//редактор текста для различных сообщений
var ckeditor_slim = {
            language : 'ru',
            toolbar : [ 
                { name: 'basicstyles', items: [ 'Bold', 'Italic', 'Underline', 'Strike', '-', 'RemoveFormat' ] },
                { name: 'paragraph', groups: [ 'list', 'indent', 'align' ], items: [ 'NumberedList', 'BulletedList'] }, 
                { name: 'links', items: [ 'Link', 'Unlink' ] },
                { name: 'insert', items: [ 'Image', 'quote_btn', 'spoiler_btn', 'user_btn', 'smile_btn' ] }
            ]
        };

/**
* перезагружает страницу с добавлением выбранного per_page
* 
* @param select
*/
function page_limit(select){ 
    var url = window.location.href.urlQueryParameter('page_limit',select.val());
    url = url.urlQueryParameter('page','1');
    window.location.href = url;        
}
        
/**
 * показывает скрывает блок 
 */
function toggleThis(item){  
    var item = $(item);
    if(item.attr('data-toggle')=='1'){ 
        item.show().attr('data-toggle', '0'); 
        return true;  
    }else{
        item.hide().attr('data-toggle', '1'); 
        return false;
    }        
}

/**
* вставляет прелоадер в указанный jquery элемент с указанным типом 
* 
* @param item
* @param type
*/
function set_preloader(item, type){
    if(type=='loading-spinner-blue'){
        item.html('<img src="/themes/assets/global/img/loading-spinner-blue.gif" alt="Загрузка" title="Загрузка" />');    
    }
    if(type=='input-spinner'){
        item.html('<img src="/themes/assets/global/img/input-spinner.gif" alt="Загрузка" title="Загрузка" />');    
    }    
}

/**
* Проверяет есть ли у какого нибудь родителя (и у себя) указанный id или class
* 
* @param item
* @param val
* 
* @returns {Boolean}
*/
function is_have_in_tree(item, val){
    //проверим его самого
    if(item.hasClass(val) || item.attr('id') == val){
        return true;
    }
    //првоерим родителя
    var parent = item.parent();
    if(parent.length > 0){
        if(parent.hasClass(val) || parent.attr('id') == val){
            return true;
        }    
    }
    //если у родителя есть родитель то в рекурсию
    if(parent.parent().length > 0){
        return is_have_in_tree(parent, val);    
    }
    return false;
}

/**
* добавляет параметр к url
* 
* @param value
* 
* @returns {String}
*/
String.prototype.urlQueryParameter = function (key, value) {
    var uri = this;   
    if (uri instanceof String || typeof uri == 'string') { 
        var regEx = new RegExp("([?|&])" + key + "=.*?(&|$)", "i");
        var separator = uri.indexOf('?') !== -1 ? "&" : "?";
        if (uri.match(regEx))
            uri = uri.replace(regEx, '$1' + key + "=" + value + '$2');
        else
            uri = uri + separator + key + "=" + value;
    }
    return uri;
};

/**
* выдаёт нужный варинт в зависимости от числа
* 
* @param amount
* @param variants
*/
function choose_plural(amount, variants){

    amount = Math.abs(amount);
    var mod10 = amount%10;
    var mod100 = amount%100;
    var variant = 0;

    if (mod10 == 1 && mod100 != 11){
        variant = 0;   
    }else if(mod10 >= 2 && mod10 <= 4 && !(mod100 > 10 && mod100 < 20)){
        variant = 1;    
    }else{
        variant = 2;
    }
    return variants[variant];    
}

/**
* simple implementation based on $.extend() from jQuery
* 
* @returns {Object}
*/
function merge() {
    var obj, name, copy,
        target = arguments[0] || {},
        i = 1,
        length = arguments.length;

    for (; i < length; i++) {
        if ((obj = arguments[i]) != null) {
            for (name in obj) {
                copy = obj[name];

                if (target === copy) {
                    continue;
                }
                else if (copy !== undefined) {
                    target[name] = copy;
                }
            }
        }
    }

    return target;
};

function poll_vote(poll_id,variant){
    //запрос
    $.post("/misc.ajax?act=poll_vote", { 
        poll_id: poll_id,
        variant: variant
    }, function(data){  
        //сообщение
        if(data.status=='fail'){
            toastr.error(data.text, 'Ошибка!');
        } 
        //сообщение
        if(data.status=='success'){
            toastr.success(data.text, 'Успех!');
            var poll = $("#poll-"+poll_id); 
            //откроем результаты
            poll.find(".results").show();
            poll.find(".vars").hide();
            //выставим значения
            for(var key in data.vars) { 
                poll.find(".results .result-"+key+" .fill").css({width: data.vars[key]['percent_of_max']+'%'});
                poll.find(".results .result-"+key+" .count").html(data.vars[key]['count']);
                poll.find(".results .result-"+key+" .percent").html(data.vars[key]['percent']+"%");
            }
            poll.find(".all-count").html(data.vote_count);
            poll.find(".vote-text").html(choose_plural(data.vote_count,['проголосовал','проголосовало','проголосовали']));
            poll.find(".user-text").html(choose_plural(data.vote_count,['пользователь','пользователя','пользователей']));
        } 
    },"json");    
}

function addslashes(str) {
  return (str + '')
    .replace(/[\\"']/g, '\\$&')
    .replace(/\u0000/g, '\\0');
}

var variable = {
    'data': {},
    'set': function(key,val){
        variable.data[key] = val; 
    },
    'get': function(key){
        if(variable.data[key] === undefined) {
            return false;    
        }else{
            return variable.data[key];
        }    
    },  
    'update': function(){
        for(var index in variable.data) {
            $("[variable-id='"+index+"']").html(variable.data[index]);     
        }   
    },  
    'updateMailCount': function(){
        //обновим все цифры
        variable.update();
        //если 0 в главной цифре
        if(variable.get("menu_count_new_talk")==0){
            //скроем цифру вообще
            $("#menu_count_new_talk").hide();    
        }else{
            //покажем
            $("#menu_count_new_talk").show();
        }
        //если ноль в любых других
        var variable_class = $("[variable-id='menu_count_new_mail']").attr('variable-class');
        if(variable.get("menu_count_new_mail")==0){
            $("[variable-id='menu_count_new_mail']").removeClass(variable_class).addClass("badge-default");    
        }else{
            $("[variable-id='menu_count_new_mail']").removeClass("badge-default").addClass(variable_class); 
        }
        variable_class = $("[variable-id='menu_count_new_mail_dialogue']").attr('variable-class');
        if(variable.get("menu_count_new_mail_dialogue")==0){
            $("[variable-id='menu_count_new_mail_dialogue']").removeClass(variable_class).addClass("badge-default");    
        }else{
            $("[variable-id='menu_count_new_mail_dialogue']").removeClass("badge-default").addClass(variable_class); 
        }
    },
    'updateWorkCount': function(){
        //обновим все цифры
        variable.update();
        //если 0 в главной цифре
        if(variable.get("menu_count_new_work")==0){
            //скроем цифру вообще
            $("#menu_count_new_work").hide();    
        }else{
            //покажем
            $("#menu_count_new_work").show();
        }
    },
    'updateAdvertCount': function(){
        //обновим все цифры
        variable.update();
        //если 0 в главной цифре
        if(variable.get("menu_count_new_advert")==0){
            //скроем цифру вообще
            $("#menu_count_new_advert").hide();    
        }else{
            //покажем
            $("#menu_count_new_advert").show();
        }
    }
};

/**
 * слежка за материалом
 */
function make_sub(object_id,object_type){ 
    //запрос
    $.post("/misc.ajax?act=make_sub", { 
        object_id: object_id,
        object_type: object_type
    }, function(data){  
        //сообщение
        if(data.status=='fail'){
            toastr.error(data.text, 'Ошибка!');
        } 
        //сообщение
        if(data.status=='success'){
            if(data.state=='on'){
                $("#sub-box-"+object_id+" .state-on").show();    
                $("#sub-box-"+object_id+" .state-off").hide(); 
            }else{
                $("#sub-box-"+object_id+" .state-on").hide();    
                $("#sub-box-"+object_id+" .state-off").show();
            }      
        }    
    },"json");    
}

function unserialize(data) {
  //  discuss at: http://phpjs.org/functions/unserialize/
  // original by: Arpad Ray (mailto:arpad@php.net)
  // improved by: Pedro Tainha (http://www.pedrotainha.com)
  // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: Chris
  // improved by: James
  // improved by: Le Torbi
  // improved by: Eli Skeggs
  // bugfixed by: dptr1988
  // bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // bugfixed by: Brett Zamir (http://brett-zamir.me)
  //  revised by: d3x
  //    input by: Brett Zamir (http://brett-zamir.me)
  //    input by: Martin (http://www.erlenwiese.de/)
  //    input by: kilops
  //    input by: Jaroslaw Czarniak
  //        note: We feel the main purpose of this function should be to ease the transport of data between php & js
  //        note: Aiming for PHP-compatibility, we have to translate objects to arrays
  //   example 1: unserialize('a:3:{i:0;s:5:"Kevin";i:1;s:3:"van";i:2;s:9:"Zonneveld";}');
  //   returns 1: ['Kevin', 'van', 'Zonneveld']
  //   example 2: unserialize('a:3:{s:9:"firstName";s:5:"Kevin";s:7:"midName";s:3:"van";s:7:"surName";s:9:"Zonneveld";}');
  //   returns 2: {firstName: 'Kevin', midName: 'van', surName: 'Zonneveld'}

  var that = this,
    utf8Overhead = function (chr) {
      // http://phpjs.org/functions/unserialize:571#comment_95906
      var code = chr.charCodeAt(0);
      if (code < 0x0080) {
        return 0;
      }
      if (code < 0x0800) {
        return 1;
      }
      return 2;
    };
  error = function (type, msg, filename, line) {
    throw new that.window[type](msg, filename, line);
  };
  read_until = function (data, offset, stopchr) {
    var i = 2,
      buf = [],
      chr = data.slice(offset, offset + 1);

    while (chr != stopchr) {
      if ((i + offset) > data.length) {
        error('Error', 'Invalid');
      }
      buf.push(chr);
      chr = data.slice(offset + (i - 1), offset + i);
      i += 1;
    }
    return [buf.length, buf.join('')];
  };
  read_chrs = function (data, offset, length) {
    var i, chr, buf;

    buf = [];
    for (i = 0; i < length; i++) {
      chr = data.slice(offset + (i - 1), offset + i);
      buf.push(chr);
      length -= utf8Overhead(chr);
    }
    return [buf.length, buf.join('')];
  };
  _unserialize = function (data, offset) {
    var dtype, dataoffset, keyandchrs, keys, contig,
      length, array, readdata, readData, ccount,
      stringlength, i, key, kprops, kchrs, vprops,
      vchrs, value, chrs = 0,
      typeconvert = function (x) {
        return x;
      };

    if (!offset) {
      offset = 0;
    }
    dtype = (data.slice(offset, offset + 1))
      .toLowerCase();

    dataoffset = offset + 2;

    switch (dtype) {
    case 'i':
      typeconvert = function (x) {
        return parseInt(x, 10);
      };
      readData = read_until(data, dataoffset, ';');
      chrs = readData[0];
      readdata = readData[1];
      dataoffset += chrs + 1;
      break;
    case 'b':
      typeconvert = function (x) {
        return parseInt(x, 10) !== 0;
      };
      readData = read_until(data, dataoffset, ';');
      chrs = readData[0];
      readdata = readData[1];
      dataoffset += chrs + 1;
      break;
    case 'd':
      typeconvert = function (x) {
        return parseFloat(x);
      };
      readData = read_until(data, dataoffset, ';');
      chrs = readData[0];
      readdata = readData[1];
      dataoffset += chrs + 1;
      break;
    case 'n':
      readdata = null;
      break;
    case 's':
      ccount = read_until(data, dataoffset, ':');
      chrs = ccount[0];
      stringlength = ccount[1];
      dataoffset += chrs + 2;

      readData = read_chrs(data, dataoffset + 1, parseInt(stringlength, 10));
      chrs = readData[0];
      readdata = readData[1];
      dataoffset += chrs + 2;
      if (chrs != parseInt(stringlength, 10) && chrs != readdata.length) {
        error('SyntaxError', 'String length mismatch');
      }
      break;
    case 'a':
      readdata = {};

      keyandchrs = read_until(data, dataoffset, ':');
      chrs = keyandchrs[0];
      keys = keyandchrs[1];
      dataoffset += chrs + 2;

      length = parseInt(keys, 10);
      contig = true;

      for (i = 0; i < length; i++) {
        kprops = _unserialize(data, dataoffset);
        kchrs = kprops[1];
        key = kprops[2];
        dataoffset += kchrs;

        vprops = _unserialize(data, dataoffset);
        vchrs = vprops[1];
        value = vprops[2];
        dataoffset += vchrs;

        if (key !== i)
          contig = false;

        readdata[key] = value;
      }

      if (contig) {
        array = new Array(length);
        for (i = 0; i < length; i++)
          array[i] = readdata[i];
        readdata = array;
      }

      dataoffset += 1;
      break;
    default:
      error('SyntaxError', 'Unknown / Unhandled data type(s): ' + dtype);
      break;
    }
    return [dtype, dataoffset - offset, typeconvert(readdata)];
  };

  return _unserialize((data + ''), 0)[2];
}
/**
* не угодные браузеры
*/
function isBadBrowser(){
    if($.browser.opera && parseFloat($.browser.version)<15){
        return true;
    }    
    if($.browser.msie && parseFloat($.browser.version)<8){
        return true;
    }    
    if($.browser.mozilla && parseFloat($.browser.version)<3.6){
        return true;
    }
}
/**
* content claim open
*/
var current_claim_object_type = false;
var current_claim_object_id = false;
function content_claim(type, object_id){
    current_claim_object_type = type;
    current_claim_object_id = object_id; 
    var content_claim_box = $("#content-claim-"+object_id);
    var last_html = content_claim_box.html();
    //загрузка
    set_preloader(content_claim_box,'loading-spinner-blue');
    //запрос
    $.post("/misc.ajax?act=content_claim", { 
        object_id: object_id,
        object_type: type
    }, function(data){  
        //сообщение
        if(data.status=='fail'){
            toastr.error(data.text, 'Ошибка!');       
        } 
        //сообщение
        if(data.status=='success'){
            //откроем форму
            $("#contentClaimModal").modal();
            //форма сама
            $("#contentClaimModal .modal-body").html(data.html);
            Metronic.handleUniformIn("#contentClaimModal");    
        }    
        //вернём кнопку
        content_claim_box.html(last_html);
    },"json");    
}
/**
* content claim send
* 
*/
function content_claim_send(){
    //прогрессбар
    $("#contentClaimModal .send-btn").button('loading'); 
    //запрос
    $.post("/misc.ajax?act=content_claim_send", { 
        object_id: current_claim_object_id,
        object_type: current_claim_object_type,
        description: $("#content-claim-description").val()
    }, function(data){  
        //сообщение
        if(data.status=='fail'){
            $("#contentClaimModal .response-box").html('<div class="alert alert-danger no-bottom-margin">\
                            <strong>Ошибка!</strong> '+data.text+'\
                        </div>');       
        } 
        //сообщение
        if(data.status=='success'){
            $("#contentClaimModal .response-box").html('<div class="alert alert-success no-bottom-margin">\
                            <strong>Успех!</strong> '+data.text+'\
                        </div>');
            //закроем окно через пол секунды
            setTimeout(function() {
                $('#contentClaimModal').modal('hide');
            }, 1000);    
        }    
        //прогрессбар
        $("#contentClaimModal .send-btn").button('reset');
    },"json");        
}
/**
* content claim choose fast desc
* 
*/
function content_claim_fast_description(){
    if($("#content-claim-desc-selector option:selected").val()!='no'){
        $("#content-claim-description").val($("#content-claim-desc-selector option:selected").val());
    }    
}
/**
* get selected text
* 
* @returns {String}
*/
function getSelectionText() {
    var text = "";
    if (window.getSelection) {
        text = window.getSelection().toString();
    } else if (document.selection && document.selection.type != "Control") {
        text = document.selection.createRange().text;
    }
    return text;
}